/**
 * This class was orginally created by <Vazkii>.
 */
package xyz.brassgoggledcoders.boilerplate.lib.client.manual;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.text.TextFormatting;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.translation.I18n;
import xyz.brassgoggledcoders.boilerplate.lib.client.manual.button.GuiButtonAchievement;
import xyz.brassgoggledcoders.boilerplate.lib.client.manual.button.GuiButtonCategory;
import xyz.brassgoggledcoders.boilerplate.lib.client.manual.button.GuiButtonHistory;
import xyz.brassgoggledcoders.boilerplate.lib.client.manual.button.GuiButtonInvisible;
import xyz.brassgoggledcoders.boilerplate.lib.client.manual.button.GuiButtonOptions;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.BotaniaAPI;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.LexiconCategory;
import xyz.brassgoggledcoders.boilerplate.lib.common.utils.Utils;

public class GuiLexicon extends GuiScreen {

	public static GuiLexicon currentOpenLexicon = new GuiLexicon();
	public static ItemStack stackUsed;

	public static HashMap<String, String> notes = new HashMap<String, String>();

	private static final String TAG_TYPE = "type";

	public static final ResourceLocation texture = new ResourceLocation(Utils.getCurrentMod().getPrefix() + "textures/gui/manual/manual.png");

	public float lastTime = 0F;
	public float partialTicks = 0F;
	public float timeDelta = 0F;

	public String categoryHighlight = "";

	List<LexiconCategory> allCategories;

	String title;
	int guiWidth = 146;
	int guiHeight = 180;
	int left, top;

	@Override
	public final void func_73866_w_() {
		super.func_73866_w_();
		onInitGui();
	}

	public void onInitGui() {
		allCategories = new ArrayList<>(BotaniaAPI.getAllCategories());
		Collections.sort(allCategories);

		lastTime = ClientTickHandler.ticksInGame;

		title = stackUsed.func_82833_r();
		currentOpenLexicon = this;

		left = field_146294_l / 2 - guiWidth / 2;
		top = field_146295_m / 2 - guiHeight / 2;

		field_146292_n.clear();
		if(isIndex()) {
			int x = 18;
			for(int i = 0; i < 12; i++) {
				int y = 16 + i * 12;
				field_146292_n.add(new GuiButtonInvisible((GuiLexiconIndex) this, i, left + x, top + y, 110, 10, ""));
			}
			populateIndex();
		} else if(isCategoryIndex()) {
			int categories = allCategories.size();
			for(int i = 0; i < categories + 1; i++) {
				LexiconCategory category = null;
				category = i >= categories ? null : allCategories.get(i);
				int perline = 5;
				int x = i % perline;
				int y = i / perline;

				int size = 22;
				GuiButtonCategory button = new GuiButtonCategory(i, left + 18 + x * size, top + 50 + y * size, this, category);
				field_146292_n.add(button);
			}
		}
		populateBookmarks();
		if(isMainPage()) {
			field_146292_n.add(new GuiButtonOptions(-1, left - 6, top + guiHeight - 54));
			field_146292_n.add(new GuiButtonAchievement(-2, left - 6, top + guiHeight - 40));
		}
	}

	@Override
	public void func_73863_a(int par1, int par2, float par3) {
		float time = ClientTickHandler.ticksInGame + par3;
		timeDelta = time - lastTime;
		lastTime = time;
		partialTicks = par3;

		GlStateManager.func_179131_c(1F, 1F, 1F, 1F);
		field_146297_k.field_71446_o.func_110577_a(texture);
		func_73729_b(left, top, 0, 0, guiWidth, guiHeight);

		if(isMainPage())
			drawHeader();

		super.func_73863_a(par1, par2, par3);
	}

	void drawHeader() {
		GlStateManager.func_179094_E();
		GlStateManager.func_179131_c(1F, 1F, 1F, 1F);
		Minecraft.func_71410_x().field_71446_o.func_110577_a(texture);
		func_73729_b(left - 8, top + 9, 0, 224, 140, 31);

		int color = 0xffd200;
		boolean unicode = field_146289_q.func_82883_a();
		field_146289_q.func_78276_b(title, left + 18, top + 13, color);
		field_146289_q.func_78264_a(true);
		//fontRendererObj.drawString(String.format(StatCollector.translateToLocal("botaniamisc.edition"), ItemLexicon.getEdition()), left + 24, top + 22, color);

		String s = TextFormatting.BOLD + categoryHighlight;
		field_146289_q.func_78276_b(s, left + guiWidth / 2 - field_146289_q.func_78256_a(s) / 2, top + 36, 0);

		field_146289_q.func_78264_a(unicode);
		GlStateManager.func_179121_F();

		categoryHighlight = "";
	}

	boolean isMainPage() {
		return true;
	}

	@Override
	protected void func_146284_a(GuiButton par1GuiButton) {
		if(par1GuiButton instanceof GuiButtonCategory) {
			LexiconCategory category = ((GuiButtonCategory) par1GuiButton).getCategory();

			field_146297_k.func_147108_a(new GuiLexiconIndex(category));
		}
	}

	@Override
	public boolean func_73868_f() {
		return false;
	}

	public int bookmarkWidth(String b) {
		if(field_146289_q == null)
			field_146289_q = Minecraft.func_71410_x().field_71466_p;

		boolean unicode = field_146289_q.func_82883_a();
		field_146289_q.func_78264_a(true);
		int width = field_146289_q.func_78256_a(b) + 15;
		field_146289_q.func_78264_a(unicode);
		return width;
	}

	String getTitle() {
		return title;
	}

	String getSubtitle() {
		return null;
	}

	int getTitleHeight() {
		return getSubtitle() == null ? 12 : 22;
	}

	boolean isIndex() {
		return false;
	}

	boolean isChallenge() {
		return false;
	}

	boolean isCategoryIndex() {
		return true;
	}

	void populateIndex() {
		List<LexiconCategory> categoryList = BotaniaAPI.getAllCategories();
		int shift = 2;
		for(int i = shift; i < 12; i++) {
			int i_ = i - shift;
			GuiButtonInvisible button = (GuiButtonInvisible) field_146292_n.get(i);
			LexiconCategory category = i_ >= categoryList.size() ? null : categoryList.get(i_);
			if(category != null)
				button.field_146126_j = I18n.func_74838_a(category.getUnlocalizedName());
			else {
				button.field_146126_j = I18n.func_74838_a("botaniamisc.lexiconIndex");
				break;
			}
		}
	}

	void populateBookmarks() {
		List<GuiButton> remove = new ArrayList<GuiButton>();
		field_146292_n.removeAll(remove);

		if(isMainPage())
			field_146292_n.add(new GuiButtonHistory(2000, left + 138, top + guiHeight - 24, I18n.func_74838_a("botaniamisc.history"), this));
	}

	boolean closeScreenOnInvKey() {
		return true;
	}

	public static GuiLexicon create(NBTTagCompound cmp) {
		String type = cmp.func_74779_i(TAG_TYPE);
		try {
			GuiLexicon lex = (GuiLexicon) Class.forName(type).newInstance();
			if(lex != null)
				lex.load(cmp);
			if(isValidLexiconGui(lex))
				return lex;
			return null;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	public void serialize(NBTTagCompound cmp) {
		cmp.func_74778_a(TAG_TYPE, getClass().getName());
	}

	public String getNotesKey() {
		return "index";
	}

	public void load(NBTTagCompound cmp) {
		// NO-OP
	}

	public GuiLexicon copy() {
		return new GuiLexicon();
	}

	public static boolean isValidLexiconGui(GuiLexicon gui)	{
		if(gui == null)
			return false;
		if(gui.isCategoryIndex() || gui.isChallenge())
			return true;
		if(gui.isIndex()) {
			GuiLexiconIndex indexGui = (GuiLexiconIndex) gui;
			if(indexGui.category == null)
				return true;
			return BotaniaAPI.getAllCategories().contains(indexGui.category);
		}

		GuiLexiconEntry entryGui = (GuiLexiconEntry) gui;
		if(!BotaniaAPI.getAllEntries().contains(entryGui.entry))
			return false;

		return entryGui.page < entryGui.entry.pages.size();
	}
}

