/**
 * This class was created by <Vazkii>. It's distributed as
 * part of the Botania Mod. Get the Source Code in github:
 * https://github.com/Vazkii/Botania
 *
 * Botania is Open Source and distributed under the
 * Botania License: http://botaniamod.net/license.php
 *
 * File Created @ [Jan 14, 2014, 6:47:06 PM (GMT)]
 */
package xyz.brassgoggledcoders.boilerplate.lib.client.manual;

import java.awt.Desktop;
import java.io.IOException;
import java.net.URI;
import java.util.List;

import net.minecraft.util.text.translation.I18n;
import org.lwjgl.input.Mouse;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.text.TextFormatting;
import xyz.brassgoggledcoders.boilerplate.lib.client.manual.button.GuiButtonBackWithShift;
import xyz.brassgoggledcoders.boilerplate.lib.client.manual.button.GuiButtonPage;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.BotaniaAPI;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.IAddonEntry;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.IGuiLexiconEntry;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.LexiconEntry;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.LexiconPage;

public class GuiLexiconEntry extends GuiLexicon implements IGuiLexiconEntry, IParented {

	private static final String TAG_ENTRY = "entry";
	private static final String TAG_PAGE = "page";

	public int page = 0;
	public boolean firstEntry = false;
	LexiconEntry entry;
	GuiScreen parent;
	String title;
	String subtitle;

	GuiButton leftButton, rightButton, backButton;

	public GuiLexiconEntry() {
		parent = new GuiLexicon();
		setTitle();
	}

	public GuiLexiconEntry(LexiconEntry entry, GuiScreen parent) {
		this.entry = entry;
		this.parent = parent;
		setTitle();
	}

	public void setTitle() {
		if(entry == null) {
			title = "(null)";
			return;
		}

		title = I18n.func_74838_a(entry.getUnlocalizedName());
		if(entry instanceof IAddonEntry)
			subtitle = I18n.func_74838_a(((IAddonEntry) entry).getSubtitle());
		else subtitle = null;
	}

	@Override
	public void onInitGui() {
		super.onInitGui();

		field_146292_n.add(backButton = new GuiButtonBackWithShift(0, left + guiWidth / 2 - 8, top + guiHeight + 2));
		field_146292_n.add(leftButton = new GuiButtonPage(1, left, top + guiHeight - 10, false));
		field_146292_n.add(rightButton = new GuiButtonPage(2, left + guiWidth - 18, top + guiHeight - 10, true));

		if(!GuiLexicon.isValidLexiconGui(this))	{
			currentOpenLexicon = new GuiLexicon();
			field_146297_k.func_147108_a(currentOpenLexicon);
			return;
		}

		LexiconPage page = entry.pages.get(this.page);

		page.onOpened(this);
		updatePageButtons();
		GuiLexiconHistory.visit(entry);
	}

	@Override
	public LexiconEntry getEntry() {
		return entry;
	}

	@Override
	public int getPageOn() {
		return page;
	}

	@Override
	boolean isMainPage() {
		return false;
	}

	@Override
	String getTitle() {
		return String.format("%s " + TextFormatting.ITALIC + "(%s/%s)", title, page + 1, entry.pages.size());
	}

	@Override
	String getSubtitle() {
		return subtitle;
	}

	@Override
	boolean isCategoryIndex() {
		return false;
	}

	@Override
	protected void func_146284_a(GuiButton par1GuiButton) {
		LexiconPage currentPage = entry.pages.get(page);
		LexiconPage newPage;
		
			switch(par1GuiButton.field_146127_k) {
			case 0 :
				currentPage.onClosed(this);
				field_146297_k.func_147108_a(GuiScreen.func_146272_n() ? new GuiLexicon() : parent);
				break;
			case 1 :
				currentPage.onClosed(this);
				page--;
				newPage = entry.pages.get(page);
				newPage.onOpened(this);
				break;
			case 2 :
				currentPage.onClosed(this);
				page++;
				newPage = entry.pages.get(page);
				newPage.onOpened(this);
				break;
			case 3 :
				Minecraft mc = Minecraft.func_71410_x();
				String cmd = "/botania-share " + entry.getUnlocalizedName();

				mc.field_71456_v.func_146158_b().func_146239_a(cmd);
				mc.field_71439_g.func_71165_d(cmd);
				break;
			case 4 :
				try {
					if(Desktop.isDesktopSupported())
						Desktop.getDesktop().browse(new URI(entry.getWebLink()));
				} catch(Exception e) {
					e.printStackTrace();
				}
			}

		updatePageButtons();
		currentPage.onActionPerformed(this, par1GuiButton);
	}

	public GuiLexiconEntry setFirstEntry() {
		firstEntry = true;
		return this;
	}

	public void updatePageButtons() {
		leftButton.field_146124_l = page != 0;
		rightButton.field_146124_l = page + 1 < entry.pages.size();
		if(firstEntry)
			backButton.field_146124_l = !rightButton.field_146124_l;
	}

	@Override
	public void func_73863_a(int par1, int par2, float par3) {
		super.func_73863_a(par1, par2, par3);

		LexiconPage page = entry.pages.get(this.page);
		page.renderScreen(this, par1, par2);
	}

	@Override
	public void func_73876_c() {
		super.func_73876_c();

		LexiconPage page = entry.pages.get(this.page);
		page.updateScreen(this);
	}

	@Override
	public int getLeft() {
		return left;
	}

	@Override
	public int getTop() {
		return top;
	}

	@Override
	public int getWidth() {
		return guiWidth;
	}

	@Override
	public int getHeight() {
		return guiHeight;
	}

	@Override
	public float getZLevel() {
		return field_73735_i;
	}

	@Override
	public void setParent(GuiLexicon gui) {
		parent = gui;
	}

	int fx = 0;
	boolean swiped = false;

	@Override
	protected void func_146273_a(int x, int y, int button, long time) {
		if(button == 0 && Math.abs(x - fx) > 100 && field_146297_k.field_71474_y.field_85185_A && !swiped) {
			double swipe = (x - fx) / Math.max(1, (double) time);
			if(swipe < 0.5) {
				nextPage();
				swiped = true;
			} else if(swipe > 0.5) {
				prevPage();
				swiped = true;
			}
		}
	}

	@Override
	protected void func_73864_a(int par1, int par2, int par3) throws IOException {
		super.func_73864_a(par1, par2, par3);

		fx = par1;
		switch(par3) {
		case 1:
			back();
			break;
		case 3:
			nextPage();
			break;
		case 4:
			prevPage();
			break;
		}
	}

	@Override
	public void func_146274_d() throws IOException {
		super.func_146274_d();

		if(Mouse.getEventButton() == 0)
			swiped = false;

		int w = Mouse.getEventDWheel();
		if(w < 0)
			nextPage();
		else if(w > 0)
			prevPage();
	}

	@Override
	protected void func_73869_a(char par1, int par2) {

		LexiconPage page = entry.pages.get(this.page);
		page.onKeyPressed(par1, par2);

		if(par2 == 1) {
			field_146297_k.func_147108_a(null);
			field_146297_k.func_71381_h();
		} else if(par2 == 203 || par2 == 200 || par2 == 201) // Left, Up, Page Up
			prevPage();
		else if(par2 == 205 || par2 == 208 || par2 == 209) // Right, Down Page Down
			nextPage();
		if(par2 == 14) // Backspace
			back();
		else if(par2 == 199) { // Home
			field_146297_k.func_147108_a(new GuiLexicon());
		}
	}

	void back() {
		if(backButton.field_146124_l) {
			func_146284_a(backButton);
			backButton.func_146113_a(field_146297_k.func_147118_V());
		}
	}

	void nextPage() {
		if(rightButton.field_146124_l) {
			func_146284_a(rightButton);
			rightButton.func_146113_a(field_146297_k.func_147118_V());
		}
	}

	void prevPage() {
		if(leftButton.field_146124_l) {
			func_146284_a(leftButton);
			leftButton.func_146113_a(field_146297_k.func_147118_V());
		}
	}

	@Override
	public List<GuiButton> getButtonList() {
		return field_146292_n;
	}

	@Override
	public float getElapsedTicks() {
		return lastTime;
	}

	@Override
	public float getPartialTicks() {
		return partialTicks;
	}

	@Override
	public float getTickDelta() {
		return timeDelta;
	}

	@Override
	public void serialize(NBTTagCompound cmp) {
		super.serialize(cmp);
		cmp.func_74778_a(TAG_ENTRY, entry.getUnlocalizedName());
		cmp.func_74768_a(TAG_PAGE, page);
	}

	@Override
	public void load(NBTTagCompound cmp) {
		super.load(cmp);

		String entryStr = cmp.func_74779_i(TAG_ENTRY);
		for(LexiconEntry entry : BotaniaAPI.getAllEntries())
			if(entry.getUnlocalizedName().equals(entryStr)) {
				this.entry = entry;
				break;
			}

		page = cmp.func_74762_e(TAG_PAGE);

		setTitle();
	}

	@Override
	public GuiLexicon copy() {
		GuiLexiconEntry gui = new GuiLexiconEntry(entry, this.parent);
		gui.page = page;
		gui.setTitle();
		return gui;
	}

	@Override
	public String getNotesKey() {
		return "entry_" + entry.unlocalizedName + "_" + page;
	}
}
