/**
 * This class was created by <Vazkii>. It's distributed as
 * part of the Botania Mod. Get the Source Code in github:
 * https://github.com/Vazkii/Botania
 * 
 * Botania is Open Source and distributed under the
 * Botania License: http://botaniamod.net/license.php
 * 
 * File Created @ [Jan 14, 2014, 5:28:21 PM (GMT)]
 */
package xyz.brassgoggledcoders.boilerplate.lib.client.manual;

import net.minecraft.client.renderer.VertexBuffer;
import org.lwjgl.opengl.GL11;

import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.util.ResourceLocation;
import xyz.brassgoggledcoders.boilerplate.lib.common.utils.Utils;

public final class IconHelper {

	public static TextureAtlasSprite forName(TextureMap ir, String name) {
		return ir.func_174942_a(new ResourceLocation(Utils.getCurrentMod().getPrefix() + name));
	}

	public static TextureAtlasSprite forName(TextureMap ir, String name, String dir) {
		return ir.func_174942_a(new ResourceLocation(Utils.getCurrentMod().getPrefix() + dir + "/" + name));
	}

	/**
	 * Renders a sprite from the spritesheet with depth, like a "builtin/generated" item model.
	 * Adapted from ItemRenderer.renderItemIn2D, 1.7.10
	 */
	public static void renderIconIn3D(Tessellator tess, float p_78439_1_, float p_78439_2_, float p_78439_3_, float p_78439_4_, int width, int height, float thickness) {
        VertexBuffer wr = tess.func_178180_c();
        wr.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181710_j);
        wr.func_181662_b(0.0D, 0.0D, 0.0D).func_187315_a(p_78439_1_, p_78439_4_).func_181663_c(0, 0, 1).func_181675_d();
        wr.func_181662_b(1.0D, 0.0D, 0.0D).func_187315_a(p_78439_3_, p_78439_4_).func_181663_c(0, 0, 1).func_181675_d();
        wr.func_181662_b(1.0D, 1.0D, 0.0D).func_187315_a(p_78439_3_, p_78439_2_).func_181663_c(0, 0, 1).func_181675_d();
        wr.func_181662_b(0.0D, 1.0D, 0.0D).func_187315_a(p_78439_1_, p_78439_2_).func_181663_c(0, 0, 1).func_181675_d();
        tess.func_78381_a();
        wr.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181710_j);
        wr.func_181662_b(0.0D, 1.0D, (0.0F - thickness)).func_187315_a(p_78439_1_, p_78439_2_).func_181663_c(0, 0, -1).func_181675_d();
        wr.func_181662_b(1.0D, 1.0D, (0.0F - thickness)).func_187315_a(p_78439_3_, p_78439_2_).func_181663_c(0, 0, -1).func_181675_d();
        wr.func_181662_b(1.0D, 0.0D, (0.0F - thickness)).func_187315_a(p_78439_3_, p_78439_4_).func_181663_c(0, 0, -1).func_181675_d();
        wr.func_181662_b(0.0D, 0.0D, (0.0F - thickness)).func_187315_a(p_78439_1_, p_78439_4_).func_181663_c(0, 0, -1).func_181675_d();
        tess.func_78381_a();
        float f5 = 0.5F * (p_78439_1_ - p_78439_3_) / (float)width;
        float f6 = 0.5F * (p_78439_4_ - p_78439_2_) / (float)height;
        wr.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181710_j);
        int k;
        float f7;
        float f8;

        for (k = 0; k < width; ++k)
        {
            f7 = (float)k / (float)width;
            f8 = p_78439_1_ + (p_78439_3_ - p_78439_1_) * f7 - f5;
            wr.func_181662_b(f7, 0.0D, (0.0F - thickness)).func_187315_a(f8, p_78439_4_).func_181663_c(-1, 0, 0).func_181675_d();
            wr.func_181662_b(f7, 0.0D, 0.0D).func_187315_a(f8, p_78439_4_).func_181663_c(-1, 0, 0).func_181675_d();
            wr.func_181662_b(f7, 1.0D, 0.0D).func_187315_a(f8, p_78439_2_).func_181663_c(-1, 0, 0).func_181675_d();
            wr.func_181662_b(f7, 1.0D, (0.0F - thickness)).func_187315_a(f8, p_78439_2_).func_181663_c(-1, 0, 0).func_181675_d();
        }

        tess.func_78381_a();
        wr.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181710_j);
        float f9;

        for (k = 0; k < width; ++k)
        {
            f7 = (float)k / (float)width;
            f8 = p_78439_1_ + (p_78439_3_ - p_78439_1_) * f7 - f5;
            f9 = f7 + 1.0F / (float)width;
            wr.func_181662_b(f9, 1.0D, (0.0F - thickness)).func_187315_a(f8, p_78439_2_).func_181663_c(1, 0, 0).func_181675_d();
            wr.func_181662_b(f9, 1.0D, 0.0D).func_187315_a(f8, p_78439_2_).func_181663_c(1, 0, 0).func_181675_d();
            wr.func_181662_b(f9, 0.0D, 0.0D).func_187315_a(f8, p_78439_4_).func_181663_c(1, 0, 0).func_181675_d();
            wr.func_181662_b(f9, 0.0D, (0.0F - thickness)).func_187315_a(f8, p_78439_4_).func_181663_c(1, 0, 0).func_181675_d();
        }

        tess.func_78381_a();
        wr.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181710_j);

        for (k = 0; k < height; ++k)
        {
            f7 = (float)k / (float)height;
            f8 = p_78439_4_ + (p_78439_2_ - p_78439_4_) * f7 - f6;
            f9 = f7 + 1.0F / (float)height;
            wr.func_181662_b(0.0D, f9, 0.0D).func_187315_a(p_78439_1_, f8).func_181663_c(0, 1, 0).func_181675_d();
            wr.func_181662_b(1.0D, f9, 0.0D).func_187315_a(p_78439_3_, f8).func_181663_c(0, 1, 0).func_181675_d();
            wr.func_181662_b(1.0D, f9, (0.0F - thickness)).func_187315_a(p_78439_3_, f8).func_181663_c(0, 1, 0).func_181675_d();
            wr.func_181662_b(0.0D, f9, (0.0F - thickness)).func_187315_a(p_78439_1_, f8).func_181663_c(0, 1, 0).func_181675_d();
        }

        tess.func_78381_a();
        wr.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181710_j);

        for (k = 0; k < height; ++k)
        {
            f7 = (float)k / (float)height;
            f8 = p_78439_4_ + (p_78439_2_ - p_78439_4_) * f7 - f6;
            wr.func_181662_b(1.0D, f7, 0.0D).func_187315_a(p_78439_3_, f8).func_181663_c(0, -1, 0).func_181675_d();
            wr.func_181662_b(0.0D, f7, 0.0D).func_187315_a(p_78439_1_, f8).func_181663_c(0, -1, 0).func_181675_d();
            wr.func_181662_b(0.0D, f7, (0.0F - thickness)).func_187315_a(p_78439_1_, f8).func_181663_c(0, -1, 0).func_181675_d();
            wr.func_181662_b(1.0D, f7, (0.0F - thickness)).func_187315_a(p_78439_3_, f8).func_181663_c(0, -1, 0).func_181675_d();
        }

        tess.func_78381_a();

	}

}